var rdrpref = {
	lang: function(v) {
	  return document.getElementById("redirremlocale").getString(v);	
	},
	
	init: function() {
		this.prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('extensions.redirrem.');
		this.currentdoc=Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser").content;
		
		this.boolPrefs=new Array("active","menu.addtolist","menu.visit","beta.cleanimages","beta.cleanurl","highlight.nowhitelist","highlight.clean","highlight.unclean","blacklisttoggle","auto.whitelist");
		this.stringPrefs=new Array("highlight.cleanstyle","whitelist","blacklist","highlight.uncleanstyle","highlight.cleanstyle");
	},
	
	save: function() {
		if(this.liststatus!= null) {
			if(this.liststatus)
				this.whitelisttemp=this.getlist();
			else
				this.blacklisttemp=this.getlist();
		}
			
		this.prefs.setBoolPref('active',document.getElementById('active').checked);
		this.prefs.setCharPref('blacklist',this.blacklisttemp);
		this.prefs.setBoolPref('blacklisttoggle',!this.liststatus);
		this.prefs.setBoolPref('highlight.clean',document.getElementById('highlight.clean').checked);
		this.prefs.setBoolPref('auto.whitelist',document.getElementById('auto.whitelist').checked);
		this.prefs.setCharPref('highlight.cleanstyle',document.getElementById('highlight.style.clean.custom').value);
		this.prefs.setBoolPref('highlight.nowhitelist',document.getElementById('highlight.nowhitelist').checked);
		this.prefs.setBoolPref('highlight.unclean',document.getElementById('highlight.unclean').checked);
		this.prefs.setCharPref('highlight.uncleanstyle',document.getElementById('highlight.style.unclean.custom').value);
		this.prefs.setBoolPref('menu.addtolist',document.getElementById('menu.addtolist').checked);
		this.prefs.setBoolPref('menu.visit',document.getElementById('menu.visit').checked);
		this.prefs.setCharPref('whitelist',this.whitelisttemp);		
		this.prefs.setBoolPref("reloadit", true);
		return true;
	},
	
	hCheck: function(clean,check,style) {
		var un;
		if(clean) un=''; else un='un';
		var string=document.getElementById('highlight.style.'+un+'clean.custom').value;
		if(check)
		  string=string.replace(new RegExp(style,'ig'),'');
		else
			string=style+string;
			
		document.getElementById('highlight.style.'+un+'clean.custom').value=string;
		rdrpref.updateExampleLink(clean);
	},
	
	in_array: function(val, arr) {
		var i;
    for (i=0;i<arr.length;i++) {
        if (arr[i] == val) return true;
    }
    return false;
	},
	
	predefinedSettings: function(what) {
		if(!confirm(this.lang('overwritesettings'))) return false;
		var i,temp1,temp2;
		switch(what) {
			case "xeen":
				temp1=this.prefs.getCharPref('whitelist');
				temp2=this.prefs.getCharPref('blacklist');
        this.prefs.deleteBranch('');				
				this.prefs.setBoolPref("menu.addtolist", true);
				this.prefs.setBoolPref("auto.whitelist", true);
		    this.prefs.setBoolPref("menu.visit", true);
				this.prefs.setCharPref('whitelist',temp1);
				this.prefs.setCharPref('blacklist',temp2);
			  break;
			case "0.32":
				this.prefs.setCharPref('ver','0.4');
				this.prefs.setBoolPref("auto.whitelist", false);
				this.prefs.setBoolPref('active',true);
				this.prefs.setBoolPref('blacklisttoggle',false);
				this.prefs.setBoolPref('highlight.clean',true);
				this.prefs.setBoolPref('highlight.unclean',false);
				this.prefs.setCharPref('highlight.cleanstyle','color:#660000;background:#FFCC99;');
			  this.prefs.setBoolPref("menu.addtolist", false);
		    this.prefs.setBoolPref("menu.visit", false);
				break;
			case "standard":
        this.prefs.deleteBranch('');				
			  break;
		}
		this.redirreminit();
		return true;
	},
	
	exportData: function() {
		if(!confirm(this.lang('savechanges'))) return false;
    this.save();
		var i,z,patterns;
		patterns=new Array;
		z=1;
		patterns[0]='redirremminver=2'; 

		for(i=0;i<this.stringPrefs.length;i++) {
		  patterns[z]=this.stringPrefs[i]+'='+this.prefs.getCharPref(this.stringPrefs[i]);
			z++;
		}
		
		for(i=0;i<this.boolPrefs.length;i++) {
		  patterns[z]=this.boolPrefs[i]+'='+this.prefs.getBoolPref(this.boolPrefs[i]);
			z++;
		}
		this.saveToFile(patterns);
		return true;
	},
	
	importData: function() {
		var pattern=this.loadFromFile();		
		var i,patterns=new Array,appendFilters=null;
		for(i=0;i<pattern.length;i++)  patterns[i]=pattern[i].split("=",2);
		if(patterns[0][0]!="redirremminver" || ! /[0-9]+/.test(patterns[0][1])) {
			alert(this.lang('import-invalidfile'));
			return false;
		}
		if(patterns[0][1]>2) {
			alert(this.lang('import-outdated'));
			return false;
		}
		if(patterns[0][1]==1) {
			patterns[0][1]=2;
			for(i=1;i+1<patterns.length;i++) {
				if(patterns[i][0]=="highlight") patterns[i][0]="highlight.clean";
				if(patterns[i][0]=="linksh")    patterns[i][0]="highlight.cleanstyle";
				if(patterns[i][0]=="whitelist") patterns[i][1]='@@'+patterns[i][1].replace(/\s/g,' @@');
			}
			this.prefs.setBoolPref("highlight.unclean", false);
		}
		if(patterns[0][1]==2) {
			if(!this.prefs.prefHasUserValue("ver")) this.prefs.setCharPref("ver", '0.4');
			for(i=1;i+1<patterns.length;i++) {
				if(this.in_array(patterns[i][0],this.boolPrefs)) this.prefs.setBoolPref(patterns[i][0],/true/i.test(patterns[i][1]));
				if(this.in_array(patterns[i][0],this.stringPrefs)) {
					if(((patterns[i][0]=="whitelist" && this.prefs.prefHasUserValue("whitelist")) ||
							(patterns[i][0]=="blacklist" && this.prefs.prefHasUserValue("blacklist")))
						 && appendFilters==null)
					  appendFilters=confirm(this.lang('import-appendfilters'));
					if((patterns[i][0]=="whitelist" || patterns[i][0]=="blacklist") && appendFilters) {
						var tempfile,templocal,tempfinal,g;
						tempfinal='';
						tempfile=patterns[i][1].split(' ');
						templocal=this.prefs.getCharPref(patterns[i][0]).split(' ');
						for(g=0;g<tempfile.length;g++) if(!this.in_array(tempfile[g],templocal)) tempfinal+=tempfile[g]+' '; 
						for(g=0;g<templocal.length;g++) tempfinal+=templocal[g]+' ';
						this.prefs.setCharPref(patterns[i][0],tempfinal);
					} else {
						this.prefs.setCharPref(patterns[i][0],patterns[i][1]);
					}
				}
			}
			this.redirreminit();
			alert(this.lang('import-ok'));
			return true;
		}
		alert(this.lang('import-fail'));
		return false;
	},
	
	saveToFile: function(patterns) {
		// thanks to adblock
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
		var stream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);  
  
		fp.init(window, this.lang('chooselocation'), fp.modeSave);
		fp.defaultExtension='txt';
		fp.defaultString=this.lang('defaultfilename');
		fp.appendFilters(fp.filterText);
  
		if (fp.show() != fp.returnCancel) {
      if (fp.file.exists()) fp.file.remove(true);
		  fp.file.create(fp.file.NORMAL_FILE_TYPE, 0666);
			stream.init(fp.file, 0x02, 0x200, null);       	
      
			for (var i = 0; i < patterns.length ; i++) {
				patterns[i]=patterns[i]+"\n";
				stream.write(patterns[i], patterns[i].length);
			}
   
			stream.close();
		}
	},
	
	loadFromFile: function() {
		// thanks to adblock
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
		var stream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
		var streamIO = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
	
		fp.init(window, this.lang('choosefile'), fp.modeOpen);
	  fp.defaultExtension='txt';
		fp.appendFilters(fp.filterText);
	
		if (fp.show() != fp.returnCancel) {
			stream.init(fp.file, 0x01, 0444, null);
			streamIO.init(stream);
			input = streamIO.read(stream.available());
			streamIO.close();
			stream.close();			
	
			linebreak = input.match(/(((\n+)|(\r+))+)/m)[1]; // first: whole match -- second: backref-1 -- etc..
			return input.split(linebreak);
		}
		return null;
	},	
	
	hTextColor: function(clean,check,color) {		
		if(! color) color='#000000';
		var un;
		if(clean) un=''; else un='un';
		var string=document.getElementById('highlight.style.'+un+'clean.custom').value;
		string=string.replace(/background-color/ig,'background');
		
		string=string.replace(/color:#[A-F0-9]{3,6};+/ig,'');
		if(!check) string='color:'+color.replace(/;/,'')+';'+string;
			
		document.getElementById('highlight.style.'+un+'clean.custom').value=string;
		rdrpref.updateExampleLink(clean);
	},
	
	hBgColor: function(clean,check,color) {
		if(! color) color='#FFFFFF';
		var un;
		if(clean) un=''; else un='un';
		var string=document.getElementById('highlight.style.'+un+'clean.custom').value;
				
		string=string.replace(/background:#[A-F0-9]{3,6};+/ig,'');
		if(!check) string='background:'+color.replace(/;/,'')+';'+string;
			
		document.getElementById('highlight.style.'+un+'clean.custom').value=string;
		rdrpref.updateExampleLink(clean);
	},
	
	hFontSize: function(clean,check,size) {
		if(!size) size='11';
		var un;
		if(clean) un=''; else un='un';
		var string=document.getElementById('highlight.style.'+un+'clean.custom').value;
	
		string=string.replace(/font-size:[0-9]*px;+/ig,'');
		if(!check) string='font-size:'+size+'px;'+string;
			
		document.getElementById('highlight.style.'+un+'clean.custom').value=string;
		rdrpref.updateExampleLink(clean);
		return true;
	},
	
	enable: function(arr) {
	  for(var z=0;z<arr.length;z++) document.getElementById(arr[z]).disabled="";
  },

	disable: function(arr) {
		for(var z=0;z<arr.length;z++) document.getElementById(arr[z]).disabled="true";
	},
	
	check_active: function (invert,element,arr) {
		arr=arr.split(',');
		if(invert)
			if(document.getElementById(element).checked) this.disable(arr); else this.enable(arr);
		else
			if(document.getElementById(element).checked) this.enable(arr); else this.disable(arr);
	},
	
	updateExampleLink: function(clean) {
		var un;
		if(!clean) un='un'; else un='';

		var oldtext='cursor:pointer;'+document.getElementById('highlight.style.'+un+'clean.custom').value;
    var newtext=oldtext.replace(/absolute/i,'static');
		if(oldtext!=newtext && !this.absolutePositionWarningDisplayed) {
			alert(this.lang('absoluteposition'));
			this.absolutePositionWarningDisplayed=true;
		}
		document.getElementById('highlight.style.'+un+'clean.testlink').style.cssText=newtext;		
	},
	
	updateFields: function(clean) {
		var un;
		if(!clean) un='un'; else un='';
		var oldtext=document.getElementById('highlight.style.'+un+'clean.custom').value.replace(/background-color/ig,'background');
		document.getElementById('highlight.style.'+un+'clean.custom').value=oldtext;
		document.getElementById('highlight.style.'+un+'clean.bold.on').checked=/font-weight:bold;/i.test(oldtext);
		document.getElementById('highlight.style.'+un+'clean.italic.on').checked=/font-style:italic;/i.test(oldtext);
		document.getElementById('highlight.style.'+un+'clean.underline.on').checked=/text-decoration:underline;/i.test(oldtext);
		
		if(/color:#[A-F0-9]{3,6};/i.test(oldtext)) {
		  document.getElementById('highlight.style.'+un+'clean.text.on').checked=true;
			document.getElementById('highlight.style.'+un+'clean.text').color=oldtext.match(/color:(#[A-F0-9]{3,6};)/i)[1];
		} else {
			document.getElementById('highlight.style.'+un+'clean.text.on').checked=false;
		}
		
		if(/background:#[A-F0-9]{3,6};/i.test(oldtext)) {
		  document.getElementById('highlight.style.'+un+'clean.bg.on').checked=true;
			document.getElementById('highlight.style.'+un+'clean.bg').color=oldtext.match(/background:(#[A-F0-9]{3,6};)/i)[1];
		} else {
			document.getElementById('highlight.style.'+un+'clean.bg.on').checked=false;
		}
		
		if(/font-size:[0-9]*px;/i.test(oldtext)) {
		  document.getElementById('highlight.style.'+un+'clean.size.on').checked=true;
			document.getElementById('highlight.style.'+un+'clean.size').value=oldtext.match(/font-size:([0-9]*)px;/i)[1];
		} else {
			document.getElementById('highlight.style.'+un+'clean.size.on').checked=false;
		}
	},
	
	nopref_save:	function () {
		var filter=document.getElementById('newfilter').value.trim();
		if(!filter.length) return true;
		if(this.prefs.getBoolPref('blacklisttoggle'))
		  this.prefs.setCharPref('blacklist',(this.prefs.getCharPref('blacklist')+' '+filter).trim());
		else
		  this.prefs.setCharPref('whitelist',(this.prefs.getCharPref('whitelist')+' '+filter).trim());
		
		var array=rdr.catchframes(this.currentdoc);
		for (var f = 0; f < array.length; f++) {
			array[f].rdrlastcleanedlinks=0;
			rdr.unclean(array[f]);
			rdr.parse(array[f]);
		}
		return true;
	},
	
	noWhitelistCheck: function(invert) {		
		if(this.liststatus &&
			 ((invert && !document.getElementById('highlight.unclean').checked) || (!invert && document.getElementById('highlight.unclean').checked)
			))
		  this.enable(new Array('highlight.nowhitelist'));
		else
		  this.disable(new Array('highlight.nowhitelist'));
		return true;
	},
	
	check_whitelist:	function () {
	  if(this.liststatus!= null) {
			if(this.liststatus)
				this.whitelisttemp=this.getlist();
			else
				this.blacklisttemp=this.getlist();
		}
		if(document.getElementById('whitelist').selected) {
			document.getElementById('whitelistlabel').label=this.lang('whitelist');
			document.getElementById('menu.addtolist').label=this.lang('addtolistw');
			this.enable(new Array("auto.whitelist"));
			this.liststatus=true;
		} else {
			document.getElementById('whitelistlabel').label=this.lang('blacklist');
			document.getElementById('menu.addtolist').label=this.lang('addtolistb');
			this.disable(new Array("auto.whitelist"));
			this.liststatus=false;
	  }
		this.noWhitelistCheck();
		var list = document.getElementById('extensionlist');
		while (list.getRowCount() > 0) list.removeChild(list.childNodes[0]);
		this.filllist(false);
	},	
	
	redirreminit: function () {
		window.sizeToContent();
		rdr.init(); 
		document.getElementById("active").checked=this.prefs.getBoolPref("active");
		this.check_active(false,'active','blacklist,whitelist,whitelistAdd,whitelistDel,whitelistMod,extensionlist,auto.whitelist');
		
		this.blacklisttemp=this.prefs.getCharPref("blacklist");
		this.whitelisttemp=this.prefs.getCharPref("whitelist");
		this.liststatus=null;
		if(!this.prefs.getBoolPref("blacklisttoggle"))
			document.getElementById('blackwhitelist').selectedIndex=0;
		else
			document.getElementById('blackwhitelist').selectedIndex=1;		
		if(!document.getElementById('whitelist').selected) this.disable('auto.whitelist');
		
		document.getElementById("highlight.clean").checked=this.prefs.getBoolPref("highlight.clean");
		this.check_active(false,'highlight.clean','highlight.style.clean.bold.on,highlight.style.clean.text.on,highlight.style.clean.text,highlight.style.clean.underline.on,highlight.style.clean.bg.on,highlight.style.clean.bg,highlight.style.clean.italic.on,highlight.style.clean.size.on,highlight.style.clean.size,highlight.style.clean.custom');
		
		document.getElementById("highlight.unclean").checked=this.prefs.getBoolPref("highlight.unclean");
		this.check_active(false,'highlight.unclean','highlight.style.unclean.bold.on,highlight.style.unclean.text.on,highlight.style.unclean.text,highlight.style.unclean.underline.on,highlight.style.unclean.bg.on,highlight.style.unclean.bg,highlight.style.unclean.italic.on,highlight.style.unclean.size.on,highlight.style.unclean.size,highlight.style.unclean.custom');
		
		document.getElementById("highlight.nowhitelist").checked=this.prefs.getBoolPref("highlight.nowhitelist");
		document.getElementById("auto.whitelist").checked=this.prefs.getBoolPref("auto.whitelist");
		
		document.getElementById("highlight.style.clean.custom").value=this.prefs.getCharPref("highlight.cleanstyle");
		rdrpref.updateExampleLink(true);
		
		document.getElementById("highlight.style.unclean.custom").value=this.prefs.getCharPref("highlight.uncleanstyle");
		rdrpref.updateExampleLink(false);
		
		this.noWhitelistCheck(false);
		this.updateFields(false);
		this.updateFields(true);
		
		document.getElementById("menu.addtolist").checked=this.prefs.getBoolPref("menu.addtolist");
		document.getElementById("menu.visit").checked=this.prefs.getBoolPref("menu.visit");
	},
	
	filllist:	function () {
		var list = document.getElementById('extensionlist'),items,item;
		if(document.getElementById('blackwhitelist').selectedIndex)
		  items=this.blacklisttemp.split(' ');
		else
		  items=this.whitelisttemp.split(' ');
		for(var i=0;i<items.length;i++) {
			item=items[i].trim();
			list.appendItem(item, item.toLowerCase());	
		}
	},
	
	getlist: function() {
		var string = new String(), item;
		var list = document.getElementById('extensionlist');
		for (var i = 0; i < list.getRowCount(); ++i) {			
			item = list.getItemAtIndex(i).label;
			if (i < list.getRowCount() - 1) 
				string = string.cat(item, ' ');
			else 
				string = string.cat(item, '');				
		}
		return string;
	},
	
	d: function(t) {
	  Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).logStringMessage('rdrPref: '+t);
  },


	delete_item: function () {
		if(!confirm(this.lang('delete'))) return true;
		var list=document.getElementById('extensionlist'),selectedIndex;
		try {
			selectedIndex = list.getIndexOfItem(list.selectedItem);
		} catch(err) {
			list.selectedItem=list.childNodes[0];	
			selectedIndex = list.getIndexOfItem(list.selectedItem);
		}
		
		list.removeChild(list.childNodes[selectedIndex]);
		if(selectedIndex-1<0)
			list.selectedItem=list.childNodes[0];	
		else
			list.selectedItem=list.childNodes[(selectedIndex-1)];
		return true;
	},
	
	mod_save: function () {
		var filter=document.getElementById('newfilter').value.trim();
		if(!filter.length) return true;
		
		var list=opener.document.getElementById('extensionlist');
		var selectedIndex = list.getIndexOfItem(list.selectedItem);
		 
		if (!list.selectedItem) return this.add_save();
	
		list.selectedItem.label = filter;
		list.selectedItem.value = filter.toLowerCase();
		return true; 
	},
	
	add_load: function () {
		document.getElementById('testurl').setAttribute('value',this.currentdoc.location.href);
		if(window.arguments[0]=='mod') {
			document.getElementById('addnewdialog').setAttribute('title',this.lang('modifyfilter'));
			document.getElementById('addnewdialog').setAttribute('ondialogaccept','return rdrpref.mod_save();');
			var list=opener.document.getElementById('extensionlist'),selectedIndex;
			try {
				selectedIndex = list.getIndexOfItem(list.selectedItem);
			} catch(err) {
				list.selectedItem=list.childNodes[0];	
				selectedIndex = list.getIndexOfItem(list.selectedItem);
			}
			document.getElementById('newfilter').setAttribute('value',list.selectedItem.label);
		}
		if(window.arguments[1]=='nopref') {
			document.getElementById('addnewdialog').setAttribute('ondialogaccept','return rdrpref.nopref_save();');
			document.getElementById('testurl').setAttribute('value',window.arguments[2]);
			arg=window.arguments[2];
			if(arg.lastIndexOf('#')>0) arg=arg.substr(0,arg.lastIndexOf('#'));
			if(arg.lastIndexOf('?')>0) arg=arg.substr(0,arg.lastIndexOf('?'));

			document.getElementById('newfilter').setAttribute('value',arg);
		}
		this.add_simple();
	},
	
	add_change:	function () {
		var matched=rdrmatch(document.getElementById('newfilter').value,document.getElementById('testurl').value.replace(/[%]3A/ig,':').replace(/[%]2f/ig,'/'));
		document.getElementById('matchoutput').value=matched;
		if(matched) 
			document.getElementById('testurl').setAttribute('style','color:darkgreen;');   
		else
			document.getElementById('testurl').setAttribute('style','color:darkred;');  
	},
	
	add_advance: function () {
		var arr = new Array('simplecommand','matchrow','testurlrow','regdesc');
		for(var i=0;i<arr.length;i++) document.getElementById(arr[i]).setAttribute('style','');   
		document.getElementById('advancedcommand').setAttribute('style','display:none;');
		document.getElementById('easydesc').setAttribute('style','display:none;');
		window.sizeToContent();
		this.add_change();
	},
	
	add_simple: function () {
		var arr = new Array('simplecommand','matchrow','testurlrow','regdesc');
		for(var i=0;i<arr.length;i++) document.getElementById(arr[i]).setAttribute('style','display:none;');  
		document.getElementById('advancedcommand').setAttribute('style','');
		document.getElementById('easydesc').setAttribute('style','');
		window.sizeToContent();
	},
	
	add_save: function () {
		var filter=document.getElementById('newfilter').value.trim();
		if(!filter.length) return true;
		opener.document.getElementById('extensionlist').appendItem(filter, filter.toLowerCase());
		return true;
	}
		
}

rdrpref.init();


String.prototype.cat = function(data, chr) {
   return this + data + chr;
}
